## Risky Artifacts
Adds 6 artifacts to ruin your run with.

- **Artifact of Origination**
	- Bosses invade the map every 10 minutes.
	- Invaders gain +50% movement speed, +30% attack speed, and +20% damage, -30% cooldown reduction, and adaptive armor (loop-only).
	- Invaders drop items when killed, with a chance to drop Pearls.
	- Boss spawn count scales based on playercount and loop count.
	- Config allows for Classic Origin, where only Imp Overlords spawn.
	
*Feedback on this would be greatly appreciated! Trying to figure out what bosses should be enabled/disabled with this (removed Beetle Queens and Worms already), or if the stat boosts need any adjustments. Once I'm more confident in the balance, I'll add a lot more config options.*

- **Artifact of Arrogance**
	- Mountain Shrines are permanent.
	
- **Artifact of Expansion**
	- Teleporter radius is mapwide, but takes longer to charge and prices are increased by 25%.
	- Doubles Moon/Void field holdout radius but increases their charge time.
	- Disables Focused Convergence while active.

- **Artifact of Conformity**
	- Prevents scrappers and printers from spawning.
	
- **Artifact of Warfare**
	- Boosts monster movement speed, attack speed, and projectile speed by 50%.
	
- **Artifact of Primacy**
	- The Primordial Teleporter spawns on every stage after looping. 
	
	
## For Mod Devs
If you are making a custom boss and want to add it to the Artifact of Origination spawn pool, add a softdependency to com.Moffein.RiskyArtifacts then do:
`Risky_Artifacts.Artifacts.Origin.AddSpawnCard(Spawncard, BossTier);`

Boss Tier affects when the boss can spawn.

Stage 1-2: 100% chance T1

Stage 3-4: 30% chance T1, 70% chance T2

Stage 5+: 25% chance T1, 65% chance T2, 10% chance T3


T1: Beetle Queen (disabled), Titan, Vagrant, Dunestrider

T2: Imp Overlord, Magma Worm, Solus Control Unit, Grovetender

T3: Grandparent

## Icon Credits

Warfare - MinHui12g

Conformity, Arrogance, Expansion, Origin - KoobyKarasu

## Installation

Place Risky_Artifacts.dll in /Risk of Rain 2/BepInEx/plugins/

## Changelog

`1.4.10`

- Fixed for latest patch?

`1.4.9`

- Conformity
	- Fixed Red/Yellow printers not getting deleted.

- Arrogance
	- Made values public for cross-mod compatibility.

`1.4.8`

- Origination
	- Boss counter no longer increases when spawning new waves in the Artifact Reliquary.
	- Added extra null checks.


`1.4.7`

- Fixed Conformity Disable in Bazaar config option.

`1.4.6`

- Added CannotSteal tag to OriginBonus.

`1.4.5`

- Added OriginBonus to BrotherBlacklist

`1.4.4`

- Fixed incompatibility issues.

`1.4.3`

- Updated for latest R2API update.
- Origin bosses now only show 1 entry on the objective HUD.
- Rewrote Conformity code to work with the new update.
	- Now destroys Printers and Scrappers after they spawn.
	- Might be buggy.

`1.4.2`

- Fixed Expansion not working when ZetTweaks is installed.
- Note: Elites are currently broken due to R2API issues. Should be fixed once that updates.

`1.4.1`

- Removed Conformity debug text.

`1.4.0`

- Updated for DLC update.
- Origination
	- Bosses are now on the Void team (can be changed in config).
	- Bosses now have a chance of dropping Void items if the DLC is enabled.
	- Disabled Grandparents by default.
	- Fixed Grandparents being unable to be disabled.
- Expansion
	- Lowered price multiplier from +30% -> +20%
	- Now affects Void Locus (uses same settings as Void Fields)

`1.3.5`
- Fixed Aetherium's Witches Ring causing Origin Bosses to drop items.

`1.3.4`
- Added missing EliteAPI submodule dependency that was causing errors on certain mod setups.

`1.3.3`
- Origination
	- Disabled per-loop boss count scaling.
	
*This was spawning too many bosses when combined with the +1 Boss Per Invasion change.*

`1.3.2`
- Origination
	- Each invasion spawns +1 extra boss, multiplied by Player Factor and Loop Factor.
	
*Origination Bosses were feeling like too much of a pushover compared to Vengeance/Worms, so their numbers have been increased.*

`1.3.1`
- Added config options for disabling artifacts.

`1.3.0`
- Origination
	- Overhauled Elite selection code so that it can select modded Elite tiers.
		- This breaks the Allow Elite Worms config option because it checks the elite spawning conditions. Mods that remove the Elite Worm restriction will be able to get around this.
	- Item Drop rarity is now based on the Elite Cost Multiplier.
		- Cost >= 3 guaranteed Greens
		- Cost >= 15 gives guaranteed Reds
		- White/Green chances decrease from their base chances to 0% linearly as the cost approaches each threshold.

`1.2.2`
- Origination
	- Made tweaks to spawning and fixed a bug that was causing less bosses to spawn than intended. Hopefully this will fix instances where bosses fail to spawn.
	- Adjusted elite boss drop odds. Since they're tanky and take up a ton of potential boss spawns which would give more loot, they need better drops to account for that.
		- If a T1 Elite drops a Pearl, it will always be an Irradiant Pearl.
		- T2 Elites are now more likely to drop Reds instead of Pearls.
		- TODO: Convert this into a consistent function that takes in a Elite's cost multiplier and adjusts drops based on that.

`1.2.1`
- Readme update.

`1.2.0`
- New Artifact: Artifact of Primacy
	- Primordial Teleporter spawns on every stage after looping.

`1.1.0`
- Origination
	- Reduced spawn count from +0.5 per player to +0.3 per player (same as how the game's difficulty scales with playercount).
	- Now tries to combine spawns into elite bosses if too many are spawning.
		- Elite Bosses drop better loot.
			- T1 Elites drop Uncommons and above.
				- If Honor is active, they drop Commons like normal unless the Ignore Honor setting is enabled.
			- T2 Elites drop Legendaries and Irradiant Pearls.
	- Reduced per-loop spawncount increase from +100% -> +50%
	- Fixed Honor bosses having more HP than intended.
	- Added config to disable forced elites for Honor.
	- Added config for what bosses can spawn.
	- Added config to disable particle effect.

`1.0.11`
- Origination
	- Fixed a bug where bosses sometimes wouldn't spawn if players are dead.
	- ??? now adds 3 extra bosses per stack.

`1.0.10`
- Origination
	- ??? now adds 2 extra bosses per stack.
	- ??? extra boss count now increases with each loop.
	- Fixed a bug where ??? stacks sometimes wouldn't be counted when spawning bosses.

*In RoR1, a single Unstable Watch could net you 7+ imps per spawn. Hoping this should make it easier to get a party going in 2.*

`1.0.9`
- Origination
	- Fixed bosses never dropping Pearls.

`1.0.8`
- Origination
	- Formula now only rounds downwards at the end so that it scales properly for even playercounts.
		- New formula is Floor((0.5 + 0.5 x LivingPlayers) x Floor(StagesCompleted/5))

`1.0.7`
- Origination
	- Bosses now only get Adaptive Armor after looping.
	- Each loop now causes extra bosses to spawn.
	- Redid how the total amount of bosses is calculated. This should fix bosses sometimes failing to spawn if certain players are dead.
		- New formula is Floor(0.5 + 0.5 x LivingPlayers) x Floor(StagesCompleted/5)

*I found that Origin bosses were feeling a bit too tanky early-on when you don't have the DPS to burst them down, but become trivial once you start looping and reach the point where you can burst them in seconds. Hoping to address both of these issues with this update. Considering making it so that multiple bosses combine into 1 elite boss if too many are spawning, but at the same time a large part of the appeal of Origin in RoR1 is the sheer amount of bosses that could spawn from it, so I'm leaving it as-is for now.*

`1.0.6`
Fixed the mod breaking when ProperSave isn't installed.

`1.0.5`
- Arrogance
	- Now supports ProperSave (Thanks kumakuma215!)

`1.0.4`
- Origination
	- Fixed bosses failing to spawn if a player is too far from an AI node.

`1.0.3`
- Origination
	- Spawn count reduced to 1 boss for every 2 players.
	
*In multiplayer, Origination can end up feeling like a cheap run-ender due to the sheer amount of HP and area suppression the bosses have, compared to regular Vengance clones who only become dangerous later into the run. This spawncount change should more closely match with how RoR2's difficulty scales with playercount, and will make taking ??? more impactful.*

`1.0.2`
- Origination
	- Damage bonus reduced +50% -> +20%
	- Attack speed bonus reduced +50% -> +30%
	- Cooldown Reduction bonus reduced -40% -> -30%
	
*The damage bonus was set to 1.5x to be lower than a T1 Elite's damage bonus, but it ended up being too much when combined with all their other attributes. -40% cooldowns and +50% attack speed were proving to be too much with Ancient Wisps, so they've been reduced slightly.*

`1.0.1`

- Fixed Expansion applying to the escape ship's holdout zone.

`1.0.0`

- Release